#include <cstdio>
#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define wGORE 2
#define wDOL -2
#define wLEWO -1
#define wPRAWO 1
#define PION 3
#define POZIOM -3
#define N 4
#define S -4
#define W 5
#define E -5

int orr(int xs,int ys, int xn, int yn){
	if(xs==xn)return PION;
	return POZIOM;
}

int kier(int xs, int ys, int xn, int yn){
	if(orr(xs,ys,xn,yn)==POZIOM)
		if(xn>xs)return wPRAWO;
		else return wLEWO;
	else
		if(yn>ys)return wGORE;
		else return wDOL;
	printf("Cos nie dziala\n");
}

struct punkt{
	int x;
	int y;
	int kierunek;
	int orientacja;
};

punkt dane[1001];
int n;
int pierwszyX;
int pierwszyY;

int wczytaj(){//zwraca 0, gdy koniec
	scanf("%d",&n);
	
	vector<pair<int,int> > A;
	for(int i=0; i<n; i++)
	{
		int x,y;
		scanf("%d%d", &x, &y);
		A.push_back(make_pair(x,y));
	}
	sort(A.begin(), A.end());
	vector< vector<int> > B(2001);
	
	
	
	
	
	
	
	
	
	
	if(n==0)return 0;
	for(int i=0;i<n;++i){
		int a,b;
		scanf("%d%d",&a,&b);
		dane[i].x=a;
		dane[i].y=b;
	}
	pierwszyX=dane[0].x;
	pierwszyY=dane[0].y;
	for(int i=0;i<n;++i){
		dane[i].kierunek=kier(dane[i].x,dane[i].y,dane[(i+1)%n].x,dane[(i+1)%n].y);
		dane[i].orientacja=orr(dane[i].x,dane[i].y,dane[(i+1)%n].x,dane[(i+1)%n].y);
	}
	return 1;
}

int indMaxLewo=0;

void fmaxLewo(){
	for(int i=0;i<n;++i){
		if(dane[i].x<dane[indMaxLewo].x)
			indMaxLewo=i;
	}
}

int indMaxGora=0;

void fmaxGora(){
	for(int i=0;i<n;++i){
		if(dane[i].y>dane[indMaxGora].y)
			indMaxGora=i;
	}
}


int wynikiPION[1001];
int wynikiPOZIOM[1001];

void liczPion(){
	fmaxLewo();
	int pierwszy=indMaxLewo;
	wynikiPION[pierwszy]=W;
	int popIndex=pierwszy;
	for(int i=1;i<=n;++i){
		if(dane[(i+pierwszy)%n].orientacja==PION){
			if(dane[popIndex].kierunek==dane[(i+pierwszy)%n].kierunek)
				wynikiPION[(i+pierwszy)%n]=wynikiPION[popIndex];
			else
				wynikiPION[(i+pierwszy)%n]=-wynikiPION[popIndex];
			popIndex=(i+pierwszy)%n;	
		}
	}
}

void liczPoziom(){
	fmaxGora();
	int pierwszy=indMaxGora;
	wynikiPOZIOM[pierwszy]=N;
	int popIndex=pierwszy;
	for(int i=1;i<=n;++i){
		if(dane[(i+pierwszy)%n].orientacja==POZIOM){
			if(dane[popIndex].kierunek==dane[(i+pierwszy)%n].kierunek)
				wynikiPOZIOM[(i+pierwszy)%n]=wynikiPOZIOM[popIndex];
			else
				wynikiPOZIOM[(i+pierwszy)%n]=-wynikiPOZIOM[popIndex];
			popIndex=(i+pierwszy)%n;	
		}
	}
}

void wypisz(){
	int start=0;
	for(start=0;start<n;++start){
		if((dane[start].x==pierwszyX)&&(dane[start].y==pierwszyY))
			break;
	}
	for(int i=start;i<n+start;++i){
		if(dane[i%n].orientacja==POZIOM){
			if(wynikiPION[i%n]==N)
				printf("N");
			else
				printf("S");
		}
		else{
			if(wynikiPOZIOM[i%n]==W)
				printf("W");
			else
				printf("E");
		}
	}
}

void drukuj(){
	for(int i=0;i<n;++i){
		cout<<dane[i].x<<" "<<dane[i].y<<" "<<dane[i].kierunek<<" "<<dane[i].orientacja<<endl;	
		cout<< "Tabwynikow\nWyniki pion:"<<wynikiPION[i];
		cout<< "Tabwynikow\nWyniki poziom:"<<wynikiPOZIOM[i];
	}
}

int main(){
	while(wczytaj()){
		drukuj();
		liczPion();
		liczPoziom();
		wypisz();
	}
	return 0;
}
